import { FormGroup } from '@angular/forms';
import { ClassType } from 'class-transformer/ClassTransformer';
import { ValidatorOptions } from 'class-validator';
import 'reflect-metadata';
import { BehaviorSubject } from 'rxjs';
export interface IShortValidationErrors {
    [key: string]: string[] | IShortValidationErrors;
}
export declare class DynamicFormGroup<TModel> extends FormGroup {
    factoryModel: ClassType<TModel>;
    fields: {
        [key: string]: any;
    };
    externalErrors: IShortValidationErrors;
    validatorOptions: ValidatorOptions;
    customValidateErrors: BehaviorSubject<IShortValidationErrors>;
    private _object;
    private _externalErrors;
    private _validatorOptions;
    constructor(factoryModel: ClassType<TModel>, fields: {
        [key: string]: any;
    });
    static getClassValidators<TModel>(factoryModel: ClassType<TModel>, fields: {
        [key: string]: any;
    }, validatorOptions?: ValidatorOptions): {};
    private onlyFields;
    object: TModel;
    private transformValidationErrors;
    classToClass<TClassModel>(object: TClassModel): TClassModel;
    plainToClass<TClassModel, Object>(cls: ClassType<TClassModel>, plain: Object): TClassModel;
    private mergeErrors;
    validate(externalErrors?: IShortValidationErrors, validatorOptions?: ValidatorOptions): void;
    private markAsInvalidForExternalErrors;
    validateAllFormFields(): void;
}
